diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/hdaudio/hdaudio.c oss-v4.1test0-070624-src-gpl/kernel/drv/hdaudio/hdaudio.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/hdaudio/hdaudio.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/hdaudio/hdaudio.c	Tue Jun 26 22:19:38 2007
@@ -597,7 +597,7 @@
       case HDA_IOCTL_READ:
 	if (!do_corb_read_simple
 	    (devc, *(unsigned int *) arg, (unsigned int *) arg))
-	  return -EIO;
+	  return RETERR(EIO);
 
 	return 0;
 	break;
@@ -632,7 +632,7 @@
   if (portc->open_mode || portc->endpoint->busy)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   if (portc->port_type == PT_INPUT)
@@ -656,7 +656,7 @@
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
       cmn_err (CE_WARN, "hda: No free DMA engines.\nn");
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   portc->open_mode = mode;
@@ -913,7 +913,7 @@
        portc->bits, portc->endpoint->stream_number, &tmp) < 0)
     {
       cmn_err (CE_WARN, "Codec setup failed\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   PCI_WRITEW (devc->osdev, engine->base + HDA_SD_FORMAT, tmp);
@@ -932,7 +932,7 @@
   hda_engine_t *engine;
 
   if (portc->port_type != PT_INPUT)
-    return -ENOTSUP;
+    return RETERR(ENOTSUP);
 
   engine = portc->engine;
 
@@ -962,7 +962,7 @@
   oss_native_word flags;
 
   if (portc->port_type != PT_OUTPUT)
-    return -ENOTSUP;
+    return RETERR(ENOTSUP);
 
   engine = portc->engine;
 
@@ -986,7 +986,7 @@
 hda_check_input (int dev)
 {
   cmn_err (CE_WARN, "Input timed out on %s.\n", audio_engines[dev]->devnode);
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
@@ -1003,7 +1003,7 @@
 								    0x03));
 #endif
   cmn_err (CE_WARN, "Output timed out on %s.\n", audio_engines[dev]->devnode);
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
@@ -1315,7 +1315,7 @@
   hdaudio_endpointinfo_t *endpoint = devc->spdifout_endpoint;
 
   if (endpoint == NULL)
-    return -EIO;
+    return RETERR(EIO);
 
   MUTEX_ENTER_IRQDISABLE (devc->low_mutex, flags);
 
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/hdaudio/hdaudio_codec.c oss-v4.1test0-070624-src-gpl/kernel/drv/hdaudio/hdaudio_codec.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/hdaudio/hdaudio_codec.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/hdaudio/hdaudio_codec.c	Tue Jun 26 22:19:39 2007
@@ -476,7 +476,7 @@
   if (size != sizeof (hdaudio_endpointinfo_t))
     {
       cmn_err (CE_WARN, "hdaudio: Bad endpoint size\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   *endpoints = (hdaudio_endpointinfo_t *) & mixer->outendpoints;
@@ -490,7 +490,7 @@
   if (size != sizeof (hdaudio_endpointinfo_t))
     {
       cmn_err (CE_WARN, "hdaudio: Bad endpoint size\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   *endpoints = (hdaudio_endpointinfo_t *) & mixer->inendpoints;
@@ -657,10 +657,10 @@
   cad = (ctrl >> 24) & 0xff;
 
   if (cad >= mixer->ncodecs)
-    return -EIO;
+    return RETERR(EIO);
 
   if (wid >= mixer->codecs[cad]->nwidgets)
-    return -EIO;
+    return RETERR(EIO);
 
   widget = &mixer->codecs[cad]->widgets[wid];
 
@@ -669,13 +669,13 @@
       {
       case CT_INGAINSEL:
 	if (!corb_read (mixer, cad, wid, 0, GET_GAIN (0, 0), ix, &a, &b))
-	  return -EIO;
+	  return RETERR(EIO);
 	return a & 0x7f;	// TODO: Handle mute
 	break;
 
       case CT_INMONO:
 	if (!corb_read (mixer, cad, wid, 0, GET_GAIN (0, 0), ix, &a, &b))
-	  return -EIO;
+	  return RETERR(EIO);
 	if (a & 0x80)
 	  left = 0;
 	else
@@ -685,13 +685,13 @@
 
       case CT_INSTEREO:
 	if (!corb_read (mixer, cad, wid, 0, GET_GAIN (0, 1), ix, &a, &b))
-	  return -EIO;
+	  return RETERR(EIO);
 	if (a & 0x80)
 	  left = 0;
 	else
 	  left = scalein_vol (a, widget->inamp_caps);
 	if (!corb_read (mixer, cad, wid, 0, GET_GAIN (0, 0), ix, &a, &b))
-	  return -EIO;
+	  return RETERR(EIO);
 	if (a & 0x80)
 	  right = 0;
 	else
@@ -701,7 +701,7 @@
 
       case CT_INMUTE:
 	if (!corb_read (mixer, cad, wid, 0, GET_GAIN (0, 0), ix, &a, &b))
-	  return -EIO;
+	  return RETERR(EIO);
 	return (a >> 7) & 0x01;
 	break;
 
@@ -711,13 +711,13 @@
 
       case CT_OUTGAINSEL:
 	if (!corb_read (mixer, cad, wid, 0, GET_GAIN (1, 1), 0, &a, &b))
-	  return -EIO;
+	  return RETERR(EIO);
 	return a;		// TODO: Handle mute
 	break;
 
       case CT_OUTMONO:
 	if (!corb_read (mixer, cad, wid, 0, GET_GAIN (1, 1), 0, &a, &b))
-	  return -EIO;
+	  return RETERR(EIO);
 	left = a & 0x7f;
 	if (a & 0x80)
 	  left = 0;
@@ -728,14 +728,14 @@
 
       case CT_OUTSTEREO:
 	if (!corb_read (mixer, cad, wid, 0, GET_GAIN (1, 1), 0, &a, &b))
-	  return -EIO;
+	  return RETERR(EIO);
 	left = a & 0x7f;
 	if (a & 0x80)
 	  left = 0;
 	else
 	  left = scalein_vol (a, widget->outamp_caps);
 	if (!corb_read (mixer, cad, wid, 0, GET_GAIN (1, 0), 0, &a, &b))
-	  return -EIO;
+	  return RETERR(EIO);
 	right = a & 0x7f;
 	if (a & 0x80)
 	  right = 0;
@@ -746,12 +746,12 @@
 
       case CT_OUTMUTE:
 	if (!corb_read (mixer, cad, wid, 0, GET_GAIN (1, 0), 0, &a, &b))
-	  return -EIO;
+	  return RETERR(EIO);
 	return (a >> 7) & 0x01;
 	break;
 
       default:
-	return -EINVAL;
+	return RETERR(EINVAL);
       }
 
   if (cmd == SNDCTL_MIX_WRITE)
@@ -877,11 +877,11 @@
 	  break;
 
 	default:
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
@@ -1051,7 +1051,7 @@
 	if (codec->mixer_init != NULL)
 	  if ((err = codec->mixer_init (dev, mixer, cad, group)) < 0)
 	    {
-	      if (err != -EAGAIN)
+	      if (err != RETERR(EAGAIN))
 		return err;
 	      /*
 	       * We got EAGAIN whic means that we should fall
@@ -1262,7 +1262,7 @@
 		      GET_PARAMETER, HDA_OUTPUTAMP_CAPS, &outamp_caps, &b))
 	{
 	  cmn_err (CE_WARN, "GET_PARAMETER HDA_OUTPUTAMP_CAPS failed\n");
-	  return -EIO;
+	  return RETERR(EIO);
 	}
       widget->outamp_caps = outamp_caps;
 
@@ -1270,7 +1270,7 @@
 		      GET_PARAMETER, HDA_INPUTAMP_CAPS, &inamp_caps, &b))
 	{
 	  cmn_err (CE_WARN, "GET_PARAMETER HDA_INPUTAMP_CAPS failed\n");
-	  return -EIO;
+	  return RETERR(EIO);
 	}
       widget->inamp_caps = inamp_caps;
     }
@@ -1918,7 +1918,7 @@
   if (cad >= MAX_CODECS)
     {
       cmn_err (CE_WARN, "hdaudio_mixer_attach: Too many codecs %d\n", cad);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   mixer->ncodecs = cad + 1;
@@ -1926,7 +1926,7 @@
   if ((codec = PMALLOC (mixer->osdev, sizeof (*codec))) == NULL)
     {
       cmn_err (CE_CONT, "Cannot allocate codec descriptor\n");
-      return -ENOMEM;
+      return RETERR(ENOMEM);
     }
 
   memset (codec, 0, sizeof (*codec));
@@ -1939,7 +1939,7 @@
     {
       cmn_err (CE_WARN, "hdaudio_mixer_attach: Codec #%d is not responding\n",
 	       cad);
-      return -EIO;
+      return RETERR(EIO);
     }
 
 /*
@@ -1989,7 +1989,7 @@
   if (!corb_read (mixer, cad, 0, 0, GET_PARAMETER, HDA_NODE_COUNT, &a, &b))
     {
       cmn_err (CE_WARN, "GET_PARAMETER HDA_NODE_COUNT3 failed\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   first_node = (a >> 16) & 0xff;
@@ -2037,7 +2037,7 @@
   for (i = first_node; i < first_node + num_nodes; i++)
     {
       if (!attach_group (mixer, cad, i, 0))
-	return -EIO;
+	return RETERR(EIO);
 
       /* power up the AFG! */
       corb_write (mixer, cad, i, 0, SET_POWER_STATE, 0);
@@ -2138,7 +2138,7 @@
       else
 	{
 	  cmn_err (CE_WARN, "hdaudio_codec: Bad bit size\n");
-	  return -EIO;
+	  return RETERR(EIO);
 	}
       break;
 
@@ -2155,7 +2155,7 @@
 
     default:
       cmn_err (CE_WARN, "hdaudio_codec: Bad format %x\n", fmt);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   corb_write (mixer, endpoint->cad, endpoint->wid, 0, SET_SPDIF_CONTROL1,
@@ -2320,14 +2320,14 @@
     case SNDCTL_DSP_GET_RECSRC:
       if (!corb_read
 	  (mixer, widget->cad, widget->wid, 0, GET_SELECTOR, 0, &a, &b))
-	return -EIO;
+	return RETERR(EIO);
       return *arg = a;
       break;
 
     case SNDCTL_DSP_SET_RECSRC:
       a = *arg;
       if (a > widget->nconn)
-	return -EIO;
+	return RETERR(EIO);
 
       corb_write (mixer, widget->cad, widget->wid, 0, SET_SELECTOR, a);
       widget->current_selector = a;
@@ -2341,14 +2341,14 @@
 	nsteps = 1;
       if (!corb_read
 	  (mixer, widget->cad, widget->wid, 0, GET_GAIN (0, 1), 0, &a, &b))
-	return -EIO;
+	return RETERR(EIO);
       if (a & 0x80)		/* Muted */
 	left = 0;
       else
 	left = ((a & 0x7f) * 100) / nsteps;
       if (!corb_read
 	  (mixer, widget->cad, widget->wid, 0, GET_GAIN (0, 0), 0, &a, &b))
-	return -EIO;
+	return RETERR(EIO);
       if (a & 0x80)		/* Muted */
 	right = 0;
       else
@@ -2398,14 +2398,14 @@
 	nsteps = 1;
       if (!corb_read
 	  (mixer, widget->cad, widget->wid, 0, GET_GAIN (1, 1), 0, &a, &b))
-	return -EIO;
+	return RETERR(EIO);
       if (a & 0x80)		/* Muted */
 	left = 0;
       else
 	left = ((a & 0x7f) * 100) / nsteps;
       if (!corb_read
 	  (mixer, widget->cad, widget->wid, 0, GET_GAIN (1, 0), 0, &a, &b))
-	return -EIO;
+	return RETERR(EIO);
       if (a & 0x80)		/* Muted */
 	right = 0;
       else
@@ -2450,7 +2450,7 @@
       break;
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 unsigned int
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/hdaudio/hdaudio_generic.c oss-v4.1test0-070624-src-gpl/kernel/drv/hdaudio/hdaudio_generic.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/hdaudio/hdaudio_generic.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/hdaudio/hdaudio_generic.c	Tue Jun 26 22:19:39 2007
@@ -485,7 +485,7 @@
   if (ext == NULL)
     {
       cmn_err (CE_WARN, "Cannot locate the mixer extension (a)\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   memset (ext->enum_present, 0, sizeof (ext->enum_present));
@@ -631,7 +631,7 @@
 	  if (ext == NULL)
 	    {
 	      cmn_err (CE_WARN, "Cannot locate the mixer extension (b)\n");
-	      return -EIO;
+	      return RETERR(EIO);
 	    }
 
 	  memset (ext->enum_present, 0, sizeof (ext->enum_present));
@@ -848,7 +848,7 @@
   if (mixer->codecs[cad] == NULL)
     {
       cmn_err (CE_WARN, "Bad codec %d\n", cad);
-      return -EIO;
+      return RETERR(EIO);
     }
   codec = mixer->codecs[cad];
 
@@ -875,7 +875,7 @@
   if (!corb_read (mixer, cad, 0, 0, GET_PARAMETER, HDA_VENDOR, &vendorid, &b))
     {
       cmn_err (CE_WARN, "Cannot get codec ID\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
 /*
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/hdaudio/hdaudio_sigmatel.c oss-v4.1test0-070624-src-gpl/kernel/drv/hdaudio/hdaudio_sigmatel.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/hdaudio/hdaudio_sigmatel.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/hdaudio/hdaudio_sigmatel.c	Tue Jun 26 22:19:39 2007
@@ -84,5 +84,5 @@
       cmn_err (CE_WARN, "Unknown sigmatel codec ID 0x%08x\n", vendorid);
     }
 
-  return -EAGAIN;
+  return RETERR(EAGAIN);
 }
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/ich/ich.c oss-v4.1test0-070624-src-gpl/kernel/drv/ich/ich.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/ich/ich.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/ich/ich.c	Tue Jun 26 22:19:39 2007
@@ -534,7 +534,7 @@
 static int
 ich_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void ich_audio_trigger (int dev, int state);
@@ -570,7 +570,7 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
   if (portc->port_type == DF_SPDIF)
     {
@@ -578,7 +578,7 @@
 	{
 	  cmn_err (CE_NOTE, "The S/PDIF device supports only playback\n");
 	  MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-	  return -EIO;
+	  return RETERR(EIO);
 	}
     }
   else
@@ -586,7 +586,7 @@
       if (devc->open_mode & mode)
 	{
 	  MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-	  return -EBUSY;
+	  return RETERR(EBUSY);
 	}
       devc->open_mode |= mode;
     }
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/imux/imux.c oss-v4.1test0-070624-src-gpl/kernel/drv/imux/imux.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/imux/imux.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/imux/imux.c	Tue Jun 26 22:19:40 2007
@@ -104,7 +104,7 @@
   imux_portc *portc;
 
   if (ctrl != 100 && (ctrl < 0 || ctrl >= devc->imux_devices))
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   portc = &devc->portc[ctrl];
 
@@ -137,7 +137,7 @@
       return left | (right << 8);
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
@@ -153,7 +153,7 @@
       {
 	value = *arg;
 	if (value <= 0 || value >= devc->hw_channels - 1)
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	portc->ch_index = value;
       }
 
@@ -209,7 +209,7 @@
       return 0;
       break;
     }
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void imux_trigger (int dev, int state);
@@ -422,7 +422,7 @@
   if (devc->hw_dev < 0 || devc->hw_dev >= num_audio_engines)
     {
       cmn_err (CE_WARN, "No audio hardware available\n");
-      return -ENXIO;
+      return RETERR(ENXIO);
     }
 
   if (devc->device_started)
@@ -442,7 +442,7 @@
       && devc->hw_dev <= devc->portc[devc->imux_devices - 1].audio_dev)
     {
       cmn_err (CE_WARN, "Bad master device %d\n", devc->hw_dev);
-      return -ENXIO;
+      return RETERR(ENXIO);
     }
 
   if (!(audio_engines[devc->hw_dev]->iformat_mask & SUPPORTED_FORMATS))
@@ -450,7 +450,7 @@
       cmn_err (CE_CONT,
 	       "Audio device %d doesn't support compatible sample formats.\n",
 	       devc->hw_dev);
-      return -EIO;
+      return RETERR(EIO);
     }
   if ((err =
        oss_audio_open_engine (devc->hw_dev, OSS_DEV_DSP, &devc->finfo, 1, 0,
@@ -490,7 +490,7 @@
       cmn_err (CE_WARN,
 	       "This device doesn't support any known sample formats (%x)\n",
 	       devc->hw_fmt);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   switch (devc->hw_fmt)
@@ -512,7 +512,7 @@
     {
       oss_audio_release (devc->hw_dev, &devc->finfo);
       cmn_err (CE_WARN, "A 2 channel soundcard (or better) is required\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   DDB (cmn_err (CE_CONT, "Started audio device %d, s=%d, c=%d, bits=%d\n",
@@ -569,7 +569,7 @@
   if (devc->hw_dev < 0)
     {
       cmn_err (CE_NOTE, "No master device allocated\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   MUTEX_ENTER_IRQDISABLE (devc->mutex, flags);
@@ -577,7 +577,7 @@
   if (portc->is_opened)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   portc->is_opened = 1;
@@ -668,7 +668,7 @@
 static int
 imux_prepare_for_output (int dev, int bsize, int bcount)
 {
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
@@ -680,7 +680,7 @@
   dmap->dmabuf_phys = 0;	/* Not mmap() capable */
   dmap->dmabuf = KERNEL_MALLOC (MY_BUFFSIZE);
   if (dmap->dmabuf == NULL)
-    return -ENOSPC;
+    return RETERR(ENOSPC);
   dmap->buffsize = MY_BUFFSIZE;
 
   return 0;
@@ -735,7 +735,7 @@
 static int
 imux_mixer_ioctl (int dev, int audiodev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static mixer_driver_t imux_mixer_driver = {
@@ -784,7 +784,7 @@
   imux_devc *devc = mixer_devs[dev]->devc;
 
   if (ctrl < 0 || ctrl >= devc->imux_devices)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (cmd == SNDCTL_MIX_READ)
     {
@@ -795,7 +795,7 @@
       return left | (right << 8);
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/maestro/maestro.c oss-v4.1test0-070624-src-gpl/kernel/drv/maestro/maestro.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/maestro/maestro.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/maestro/maestro.c	Tue Jun 26 22:19:40 2007
@@ -350,7 +350,7 @@
 pt101_mixer_get (maestro_devc * devc, int dev)
 {
   if (!((1 << dev) & PT101_MIXER_DEVS))
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   return devc->levels[dev];
 }
@@ -373,7 +373,7 @@
 
 
   if (!((1 << dev) & PT101_MIXER_DEVS))
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (!((1 << dev) & PT101_MIXER_STEREODEVS))
     {
@@ -568,7 +568,7 @@
 	  }
     }
   else
-    return -EINVAL;
+    return RETERR(EINVAL);
 }
 
 /*
@@ -1274,7 +1274,7 @@
 static int
 maestro_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void maestro_audio_trigger (int dev, int state);
@@ -1310,7 +1310,7 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->lock, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 #if 1
   if ((mode & OPEN_READ))
@@ -1325,7 +1325,7 @@
   if (devc->open_mode & mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->lock, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   devc->open_mode |= mode;
@@ -1471,7 +1471,7 @@
   if (portc->channels == 2)
     {
       cmn_err (CE_WARN, "Maestro: Stereo recording not yet supported\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 #endif
 
@@ -1733,14 +1733,14 @@
 maestro_check_input (int dev)
 {
   cmn_err (CE_WARN, "Maestro: Input timeout\n");
-  return -EIO;;
+  return RETERR(EIO);;
 }
 
 static int
 maestro_check_output (int dev)
 {
   cmn_err (CE_WARN, "Maestro: Output timeout\n");
-  return -EIO;;
+  return RETERR(EIO);;
 }
 
 static int
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/neomagic/neomagic.c oss-v4.1test0-070624-src-gpl/kernel/drv/neomagic/neomagic.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/neomagic/neomagic.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/neomagic/neomagic.c	Tue Jun 26 22:19:40 2007
@@ -65,13 +65,13 @@
   else if (devc->dev[1] == dev)
     w = 1;
   else
-    return -ENODEV;
+    return RETERR(ENODEV);
 
   targetrate = devc->portc[w].samplerate;
 
   if ((devc->portc[w].bits != 8 && devc->portc[w].bits != 16)
       || targetrate < samplerates[0] || targetrate > samplerates[7])
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   for (x = 0; x < 8; x++)
     if (targetrate < ((samplerates[x] + samplerates[x + 1]) / 2))
@@ -110,7 +110,7 @@
       return 0;
     }
   else
-    return -EINVAL;
+    return RETERR(EINVAL);
 }
 
 /* Start the play process going. */
@@ -463,7 +463,7 @@
   else
     {
       MUTEX_EXIT_IRQRESTORE (devc->low_mutex, flags);
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 }
 
@@ -790,21 +790,21 @@
   int w;
 
   if (devc == NULL)
-    return -ENODEV;
+    return RETERR(ENODEV);
 
   if (devc->dev[0] == dev)
     w = 0;
   else if (devc->dev[1] == dev)
     w = 1;
   else
-    return -ENODEV;
+    return RETERR(ENODEV);
 
   if (devc->opencnt[w] > 0)
-    return -EBUSY;
+    return RETERR(EBUSY);
 
   /* No bits set? Huh? */
   if (!((mode & OPEN_READ) || (mode & OPEN_WRITE)))
-    return -EIO;
+    return RETERR(EIO);
 
   /*
    * If it's open for both read and write, and the devc's currently
@@ -837,7 +837,7 @@
 	    ~(ADEV_FIXEDRATE | ADEV_16BITONLY | ADEV_STEREOONLY);
 	}
       else
-	return -EBUSY;
+	return RETERR(EBUSY);
     }
 
   if (mode & OPEN_READ)
@@ -853,7 +853,7 @@
 	    ADEV_FIXEDRATE | ADEV_16BITONLY | ADEV_STEREOONLY;
 	}
       else
-	return -EBUSY;
+	return RETERR(EBUSY);
     }
 
   devc->opencnt[w]++;
@@ -913,7 +913,7 @@
   int which;
 
   if (devc == NULL)
-    return -ENODEV;
+    return RETERR(ENODEV);
 
   if (devc->dev[0] == dev)
     which = 0;
@@ -945,7 +945,7 @@
   int which;
 
   if (devc == NULL)
-    return -ENODEV;
+    return RETERR(ENODEV);
 
   if (devc->dev[0] == dev)
     which = 0;
@@ -969,7 +969,7 @@
   int which;
 
   if (devc == NULL)
-    return -ENODEV;
+    return RETERR(ENODEV);
 
   if (devc->dev[0] == dev)
     which = 0;
@@ -990,7 +990,7 @@
 static int
 neomagic_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 /*
@@ -1050,10 +1050,10 @@
   oss_native_word flags;
 
   if (devc == NULL)
-    return -ENODEV;
+    return RETERR(ENODEV);
 
   if (devc->is_open_record && devc->dev_for_record != dev)
-    return -EBUSY;
+    return RETERR(EBUSY);
 
   MUTEX_ENTER_IRQDISABLE (devc->mutex, flags);
   /*
@@ -1091,10 +1091,10 @@
   oss_native_word flags;
 
   if (devc == NULL)
-    return -ENODEV;
+    return RETERR(ENODEV);
 
   if (devc->is_open_play && devc->dev_for_play != dev)
-    return -EBUSY;
+    return RETERR(EBUSY);
 
   MUTEX_ENTER_IRQDISABLE (devc->mutex, flags);
   /*
@@ -1211,7 +1211,7 @@
   oss_native_word flags;
 
   if (devc == NULL)
-    return -ENODEV;
+    return RETERR(ENODEV);
 
   MUTEX_ENTER_IRQDISABLE (devc->low_mutex, flags);
   if (direction == PCM_ENABLE_OUTPUT)
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/ossusb/ossusb.c oss-v4.1test0-070624-src-gpl/kernel/drv/ossusb/ossusb.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/ossusb/ossusb.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/ossusb/ossusb.c	Tue Jun 26 22:19:40 2007
@@ -438,7 +438,7 @@
       break;
 
     default:
-      return -EIO;
+      return RETERR(EIO);
     }
 
   return value;
@@ -539,10 +539,10 @@
   usb_control_t *c;
 
   if (devc->disabled)
-    return -EPIPE;
+    return RETERR(EPIPE);
 
   if (ctrl < 0 || ctrl >= devc->ncontrols)
-    return -EIO;
+    return RETERR(EIO);
 
   c = &devc->controls[ctrl];
 
@@ -552,7 +552,7 @@
     }
 
   if (cmd != SNDCTL_MIX_WRITE)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   value = c->value = write_current_value (devc, c, value);
 
@@ -1209,7 +1209,7 @@
   ossusb_devc *devc = mixer_devs[dev]->hw_devc;
 
   if (devc->disabled)
-    return -EPIPE;
+    return RETERR(EPIPE);
 
   switch (cmd)
     {
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/ossusb/usb_midisport.c oss-v4.1test0-070624-src-gpl/kernel/drv/ossusb/usb_midisport.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/ossusb/usb_midisport.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/ossusb/usb_midisport.c	Tue Jun 26 22:19:40 2007
@@ -363,7 +363,7 @@
   if (midic->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (midic->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   midic->open_mode = mode;
@@ -386,7 +386,7 @@
       if (devc->recbuf == NULL)
 	{
 	  cmn_err (CE_CONT, "Failed to allocate the recording buffer\n");
-	  return -ENOMEM;
+	  return RETERR(ENOMEM);
 	}
 
       if ((devc->input_endpoint_handle =
@@ -395,20 +395,20 @@
 	  midic->open_mode = 0;
 	  midic->midi_input_intr = NULL;
 	  cmn_err (CE_WARN, "Cannot open audio pipe\n");
-	  return -ENOMEM;
+	  return RETERR(ENOMEM);
 	}
       if ((devc->input_pipe =
 	   udi_usb_alloc_request (devc->usbdev, devc->input_endpoint_handle,
 				  1, UDI_USBXFER_INTR_READ)) == NULL)
 	{
-	  return -EIO;
+	  return RETERR(EIO);
 	}
 
       if ((err = midisport_start_input (devc)) < 0)
 	{
 	  cmn_err (CE_CONT, "oss midisport: Input error %d\n", err);
 	  midisport_close_input (dev, mode);
-	  return -EIO;
+	  return RETERR(EIO);
 	}
     }
 
@@ -426,7 +426,7 @@
   if (queue_ix < 0 || queue_ix >= devc->num_queues)
     {
       cmn_err (CE_WARN, "Bad output queue index %d\n", queue_ix);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   q = &devc->out_queues[queue_ix];
@@ -450,7 +450,7 @@
 	  cmn_err (CE_WARN, "Failed to allocate output buffer (%d bytes)\n",
 		   QUEUE_SIZE);
 	  q->open_count--;
-	  return -ENOMEM;
+	  return RETERR(ENOMEM);
 	}
 
       if ((q->output_endpoint_handle =
@@ -458,7 +458,7 @@
 	{
 	  cmn_err (CE_WARN, "Failed to open output endpoint\n");
 	  q->open_count--;
-	  return -EIO;
+	  return RETERR(EIO);
 	}
 
       if ((q->output_pipe =
@@ -467,7 +467,7 @@
 	{
 	  cmn_err (CE_WARN, "Failed to allocate output request\n");
 	  q->open_count--;
-	  return -EIO;
+	  return RETERR(EIO);
 	}
 
     }
@@ -541,7 +541,7 @@
   if (midic->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (midic->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   midic->open_mode = mode;
@@ -622,7 +622,7 @@
   if (midic->outqueue_ix < 0 || midic->outqueue_ix >= devc->num_queues)
     {
       cmn_err (CE_WARN, "Bad output queue index %d\n", midic->outqueue_ix);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   q = &devc->out_queues[midic->outqueue_ix];
@@ -677,7 +677,7 @@
 static int
 midisport_ioctl (int dev, unsigned cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static midi_driver_t midisport_midi_input_driver = {
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/ossusb/usb_ymhmidi.c oss-v4.1test0-070624-src-gpl/kernel/drv/ossusb/usb_ymhmidi.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/ossusb/usb_ymhmidi.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/ossusb/usb_ymhmidi.c	Tue Jun 26 22:19:41 2007
@@ -218,7 +218,7 @@
   if (midic->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (midic->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   midic->open_mode = mode;
@@ -235,13 +235,13 @@
       midic->open_mode = 0;
       midic->midi_input_intr = NULL;
       cmn_err (CE_WARN, "Cannot open audio pipe\n");
-      return -ENOMEM;
+      return RETERR(ENOMEM);
     }
   if ((midic->datapipe =
        udi_usb_alloc_request (midic->usbdev, midic->endpoint_handle, 1,
 			      UDI_USBXFER_BULK_READ)) == NULL)
     {
-      return -EIO;
+      return RETERR(EIO);
     }
 
   return ymhmidi_start_input (devc, midic);
@@ -450,7 +450,7 @@
   if (midic->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (midic->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   midic->open_mode = mode;
@@ -470,7 +470,7 @@
       midic->open_mode = 0;
       midic->midi_input_intr = NULL;
       cmn_err (CE_WARN, "Cannot create MIDI parser\n");
-      return -ENOMEM;
+      return RETERR(ENOMEM);
     }
 
   if ((midic->endpoint_handle =
@@ -479,13 +479,13 @@
       midic->open_mode = 0;
       midic->midi_input_intr = NULL;
       cmn_err (CE_WARN, "Cannot open audio pipe\n");
-      return -ENOMEM;
+      return RETERR(ENOMEM);
     }
   if ((midic->datapipe =
        udi_usb_alloc_request (midic->usbdev, midic->endpoint_handle, 1,
 			      UDI_USBXFER_BULK_WRITE)) == NULL)
     {
-      return -EIO;
+      return RETERR(EIO);
     }
 
   return 0;
@@ -512,7 +512,7 @@
 static int
 ymhusb_ioctl (int dev, unsigned cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static midi_driver_t ymhusb_input_driver = {
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/ossusb/usbaudio.c oss-v4.1test0-070624-src-gpl/kernel/drv/ossusb/usbaudio.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/ossusb/usbaudio.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/ossusb/usbaudio.c	Tue Jun 26 22:19:41 2007
@@ -86,7 +86,7 @@
 
     default:
       cmn_err (CE_CONT, "oss usbaudio: Bad control size %d\n", l);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   len = udi_usb_snd_control_msg (devc->mixer_usbdev, 0,	// endpoint
@@ -99,7 +99,7 @@
   if (len < 0)
     {
       cmn_err (CE_CONT, "ossusb: Endpoint control write error %d\n", len);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   return len;
@@ -136,7 +136,7 @@
   int i, x, diff, bestdiff, l;
 
   if (devc->disabled)
-    return -EPIPE;
+    return RETERR(EPIPE);
 
   if (arg == 0)
     return portc->speed;
@@ -186,7 +186,7 @@
   ossusb_devc *devc = adev->devc;
 
   if (devc->disabled)
-    return -EPIPE;
+    return RETERR(EPIPE);
 
   return adev->min_channels;	/* max_channels should be the same too */
 }
@@ -198,7 +198,7 @@
   ossusb_devc *devc = adev->devc;
 
   if (devc->disabled)
-    return -EPIPE;
+    return RETERR(EPIPE);
 
   return adev->oformat_mask;	/* iformat_mask should be the same  too */
 }
@@ -208,9 +208,9 @@
 {
   ossusb_devc *devc = audio_engines[dev]->devc;
   if (devc->disabled)
-    return -EPIPE;
+    return RETERR(EPIPE);
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
@@ -490,7 +490,7 @@
       cmn_err (CE_CONT, "oss usbaudio: Unsupported FORMAT II tag %04x\n",
 	       fmt);
       adev->enabled = 0;
-      return -ENXIO;
+      return RETERR(ENXIO);
     }
   return 0;
 }
@@ -527,7 +527,7 @@
       portc->disabled = 1;
       adev->enabled = 0;
       portc->act_setting = devc->act_setting;
-      return -ENXIO;
+      return RETERR(ENXIO);
     }
 
   UDB (cmn_err
@@ -596,7 +596,7 @@
 			 "\noss usbaudio: Unsupported format type %d\n",
 			 d[3]);
 		adev->enabled = 0;
-		return -ENXIO;
+		return RETERR(ENXIO);
 	      }
 	    break;
 
@@ -617,7 +617,7 @@
   if (desc == NULL)
     {
       cmn_err (CE_CONT, "oss usbaudio: Bad endpoint\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   portc->endpoint_desc = desc;
@@ -647,13 +647,13 @@
   int i;
 
   if (devc->disabled)
-    return -EPIPE;
+    return RETERR(EPIPE);
 
   MUTEX_ENTER_IRQDISABLE (devc->mutex, flags);
   if (portc->open_mode != 0)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
   portc->open_mode = mode;
   MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
@@ -689,7 +689,7 @@
     {
       usbaudio_close (dev, mode);
       cmn_err (CE_WARN, "Cannot open audio pipe\n");
-      return -ENOMEM;
+      return RETERR(ENOMEM);
     }
 
   for (i = 0; i < 2; i++)
@@ -700,7 +700,7 @@
 	{
 	  usbaudio_close (dev, mode);
 	  cmn_err (CE_WARN, "Cannot alloc isoc request\n");
-	  return -ENOMEM;
+	  return RETERR(ENOMEM);
 	}
     }
 
@@ -1081,11 +1081,11 @@
   adev_p adev = audio_engines[dev];
 
   if (devc->disabled)
-    return -EPIPE;
+    return RETERR(EPIPE);
 
 
   if (adev->flags & ADEV_NOINPUT)
-    return -ENOTSUP;
+    return RETERR(ENOTSUP);
 
   portc->stopping = 0;
 
@@ -1094,7 +1094,7 @@
        portc->speed) < 0)
     {
       cmn_err (CE_CONT, "Failed to set %d Hz sampling rate\n", portc->speed);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   /*
@@ -1115,10 +1115,10 @@
   adev_p adev = audio_engines[dev];
 
   if (devc->disabled)
-    return -EPIPE;
+    return RETERR(EPIPE);
 
   if (adev->flags & ADEV_NOOUTPUT)
-    return -ENOTSUP;
+    return RETERR(ENOTSUP);
 
   portc->stopping = 0;
 
@@ -1127,7 +1127,7 @@
        portc->speed) < 0)
     {
       cmn_err (CE_CONT, "Failed to set %d Hz sampling rate\n", portc->speed);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   /*
@@ -1149,12 +1149,12 @@
       cmn_err (CE_CONT,
 	       "oss usbaudio: Audio device %d removed from the system.\n",
 	       dev);
-      return -EPIPE;
+      return RETERR(EPIPE);
     }
 
   cmn_err (CE_CONT, "oss usbaudio: Audio input timed out on device %d.\n",
 	   dev);
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
@@ -1166,12 +1166,12 @@
       cmn_err (CE_CONT,
 	       "oss usbaudio: Audio device %d removed from the system.\n",
 	       dev);
-      return -EPIPE;
+      return RETERR(EPIPE);
     }
 
   cmn_err (CE_CONT, "oss usbaudio: Audio output timed out on device %d.\n",
 	   dev);
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
